#include <windows.h>
#include "resource.h"
#include "image.h"
#include "remote.h"
#include "client.h"
#include "md5.h"

#define BLOCKSIZE 32
#define RECVSIZE 65536
#define DEFAULT_PORT 9876

bool WinResize(HWND hWnd);
extern POINT pos;

CBitmap tmpBlock;

/////////////////////////////////////////////////////////////////////////////

struct CMDHEAD{
	ULONG CMD;
	long size;
};

Client::Client(){
	port = DEFAULT_PORT;
	recvbuf = new char[RECVSIZE];
}

Client::~Client(){
	delete [] recvbuf;
}

void Client::MakeKey(unsigned char *dat,unsigned char *passwd,int key)
{
	unsigned char *p=passwd;
	while(p[0]){
		key=key+key*p[0];
		p++;
	}
	srand(key);
	p=passwd;
	int i=0;
	memset(dat,0,16);
	while(p[i]){
		dat[i&15]=dat[i&15]+(rand()&255)+p[i];
		i++;
	}
}

bool Client::Connect(HWND hWnd)
{
	soc.setPasswd(NULL,0);
	if (!soc.connect(host,port)) {
		return false;
	}

	EnableMenuItem(GetMenu(hWnd),IDM_REMOTECONNECT,MF_GRAYED);
	EnableMenuItem(GetMenu(hWnd),IDM_REMOTECLOSE,MF_ENABLED);
	EnableMenuItem(GetMenu(hWnd),IDM_REMOTEWAIT,MF_ENABLED);
	EnableMenuItem(GetMenu(hWnd),IDM_REMOTETRACE,MF_ENABLED);
	EnableMenuItem(GetMenu(hWnd),IDM_REMOTECONTROL,MF_ENABLED);
	CheckMenuRadioItem(GetMenu(hWnd),IDM_REMOTEWAIT,IDM_REMOTECONTROL,IDM_REMOTETRACE,MF_BYCOMMAND);
	mode=1;
	return true;
}
bool Client::DisConnect(HWND hWnd)
{
	// \Pbgؒf
	soc.close();

	EnableMenuItem(GetMenu(hWnd),IDM_REMOTECONNECT,MF_ENABLED);
	EnableMenuItem(GetMenu(hWnd),IDM_REMOTECLOSE,MF_GRAYED);
	EnableMenuItem(GetMenu(hWnd),IDM_REMOTEWAIT,MF_GRAYED);
	EnableMenuItem(GetMenu(hWnd),IDM_REMOTETRACE,MF_GRAYED);
	EnableMenuItem(GetMenu(hWnd),IDM_REMOTECONTROL,MF_GRAYED);
	return true;
}

int Client::CmdRecv(HWND hWnd,CBitmap *bms)
{
	int status=soc.check();
	long dat[2];
	if(status==SOCKET_ERROR){ // G[
		return -1;
	}else if(status==0){ // f[^
		return 0;
	}
	if(soc.recv(dat,8)!=8){
		// G[
		return -1;
	}
	if(dat[0]==RCMD_SENDBMP){
		// 摜
		int info[4];
		soc.recv(info,16);
		if(soc.recv(tmpBlock.pBit,dat[1]-16)!=dat[1]-16)
			return -1;
		BitBlt(bms->hdc,info[0],info[1],info[2],info[3],
			tmpBlock.hdc,0,0,SRCCOPY);
		HDC hDC=GetDC(hWnd);
		BitBlt(hDC,info[0]-pos.x,info[1]-pos.y,info[2],info[3],
			tmpBlock.hdc,0,0,SRCCOPY);
		//BitBlt(hDC,0,0,rt.right,rt.bottom,CG.bms->hdc,0,0,SRCCOPY);
		ReleaseDC(hWnd,hDC);
	}else if(dat[0]==RCMD_SENDRLE){
		// 摜(RLE)
		int info[4];
		soc.recv(info,16);
		if(soc.recv(recvbuf,dat[1]-16)!=dat[1]-16)
			return -1;
		unrle16((unsigned short*)tmpBlock.pBit,(unsigned short*)recvbuf,(dat[1]-16)>>1);
		
		BitBlt(bms->hdc,info[0],info[1],info[2],info[3],
			tmpBlock.hdc,0,0,SRCCOPY);
		HDC hDC=GetDC(hWnd);
		BitBlt(hDC,info[0]-pos.x,info[1]-pos.y,info[2],info[3],
			tmpBlock.hdc,0,0,SRCCOPY);
		//BitBlt(hDC,0,0,rt.right,rt.bottom,CG.bms->hdc,0,0,SRCCOPY);
		ReleaseDC(hWnd,hDC);
	}else if(dat[0]==0x202){ //zXgXV
		soc.recv(&hostinfo,sizeof(HOSTINFO));
		tmpBlock.Delete();
		tmpBlock.Create(hostinfo.blocksize,hostinfo.blocksize,hostinfo.depth);
		bms->Delete();
		bms->Create(hostinfo.width,hostinfo.height,hostinfo.depth);
		WinResize(hWnd);
	}else if(dat[0]==0x901){ //F؂߂ꂽ
		long authkey;
		char cpw[16];
		soc.recv(&authkey,4);
		MakeKey((unsigned char *)cpw,(unsigned char *)passwd,authkey);
		dat[0]=0x902;
		dat[1]=16;
		soc.send(dat,8);
		soc.send(cpw,16);
		soc.recv(dat,8);
		soc.recv(&hostinfo,sizeof(HOSTINFO));
		if(hostinfo.stat || dat[0]!=0x202){
			MessageBox(hWnd,"Auth error!","error",MB_OK);
			return -1;
		}
		tmpBlock.Delete();
		tmpBlock.Create(hostinfo.blocksize,hostinfo.blocksize,hostinfo.depth);
		bms->Delete();
		bms->Create(hostinfo.width,hostinfo.height,hostinfo.depth);
		WinResize(hWnd);
		MessageBox(hWnd,"Insecure connection!","caution!",MB_OK|MB_ICONWARNING);
	}else if(dat[0]==0x903){ //F؂߂ꂽ2
		char authkey[16];
		char cpw[16];
		soc.recv(&authkey,16);
		MD5 md5;
		md5.init();
		md5.update((unsigned char*)authkey,16);
		md5.update((unsigned char*)passwd,strlen(passwd));
		md5.final((unsigned char*)cpw);
		dat[0]=0x904;
		dat[1]=16;
		soc.send(dat,8);
		soc.send(cpw,16);
		if(soc.recv(dat,12)!=12 || dat[0]!=0x904 || dat[1]!=1){
			MessageBox(hWnd,"Protocol error!","Error!",MB_OK);
			return -1;
		}
		if(dat[2]<0){
			MessageBox(hWnd,"Auth error!","Error!",MB_OK);
			return -1;
		}
		if (dat[2]&1) {
			int i;
			for (i=0;i<16;i++) authkey[i]^=0xff;
			md5.init();
			md5.update((unsigned char*)authkey,sizeof(authkey));
			md5.update((unsigned char*)passwd,strlen(passwd));
			md5.final((unsigned char*)cpw);
			soc.setPasswd((char*)cpw,16);
		} else {
			MessageBox(hWnd,"Insecure connection!","caution!",MB_OK|MB_ICONWARNING);
		}
	}else{
		return -1;
	}
	return 1;
}

int Client::SendMouse(int cmd,int mouse)
{
	long dat[8]={RCMD_MOUSE,8,cmd,mouse};
	soc.send(dat,16);
	return 0;
}

int Client::SendKey(int flag,int code)
{
	long dat[8]={RCMD_KEYBD,8,flag,code};
	soc.send(dat,16);
	return 0;
}

int Client::ChgMode(int mode)
{
	long dat[8]={RCMD_CHGMODE,4,mode};
	soc.send(dat,12);
	return 0;
}


int Client::SendCmd(char *cmd)
{
	long dat[512]={RCMD_SHELLEXEC,(long)strlen(cmd)+1};
	memcpy(dat+2,cmd,dat[1]);
	soc.send(dat,8+dat[1]);
	return 0;
}

