/////////////////////////////////////////////////////////////////////////////
//				Bitmap class
//                                           Copyright(C) 2003 K-K

#include	<windows.h>
#include	<OLECTL.h>

#include "image.h"

#define INI_FILENAME "kview.ini"

struct PictureInfo
{
	long left,top;
	long width;
	long height;
	WORD x_density;
	WORD y_density;
	short colorDepth;
	HLOCAL hInfo;
};


struct SPITABLE{
	char spi[512];
	char file[64];
};


void GetModuleDir(unsigned char* exedir){
	unsigned int i,p=0;
	unsigned int l=GetModuleFileName(NULL,(char*)exedir,320);
	for(i=0;i<l;i++){
		//QoCgpc
		if ((0x81<=exedir[i] && exedir[i]<=0x9f)
			|| (0xe0<=exedir[i] && exedir[i]<=0xec))
		{
			i++;
			continue;
		}
		if (exedir[i]=='\\') p=i;
	}
	if (p)exedir[p+(p==3)]=0;
}


int CBitmap::Create(int x,int y,int d)
{
	sx=x;
	sy=y;
	flag=1;
	if(d==0)d=24;
	depth=d;
	HDC hdcWin;
	datsize=x*y*d>>3;

	memset(&bmih,0,sizeof(bmih));
	bmih.biSize=sizeof(BITMAPINFOHEADER);
	bmih.biWidth=x;
	bmih.biHeight=y;
	bmih.biPlanes=1;
	bmih.biBitCount=d;
	bmih.biSizeImage=x*y*d>>3;

	hdcWin=NULL;//GetDC(hMainWnd); /* EChEDC 擾 */

	/* DIB ƃEChEDC DIBSection 쐬 */
	dib=CreateDIBSection(NULL,(BITMAPINFO*)&bmih,DIB_RGB_COLORS,(void**)&pBit,NULL,0);

	hdc=CreateCompatibleDC(hdcWin); /* DC 쐬 */

	SelectObject(hdc,dib); /* DC DIBSection I */
	//ReleaseDC(hMainWnd,hdcWin);
	if(d==32)flag|=256;
	return 0;
}

void CBitmap::Delete(){
	if(flag){
		DeleteDC(hdc);
		DeleteObject(dib);
	}
	flag=0;
}

CBitmap::~CBitmap(){
	Delete();
}
CBitmap::CBitmap(){
	flag=0;
}


int fLoad(char* buf,char* filename,int fsize)
{
//	int p=CPack::Load(buf,filename,fsize);
//	if (p) return p;
	//@pbNt@C_Ȃʏt@C
	HANDLE hPF= CreateFile(filename, GENERIC_READ, 0, NULL, OPEN_EXISTING,
		FILE_ATTRIBUTE_NORMAL, NULL);
	if(hPF == INVALID_HANDLE_VALUE)return 0;
	ULONG size;// = GetFileSize(hPF, NULL);
	// t@Cɓǂݍ
	ReadFile(hPF, buf, fsize, &size, NULL);
	CloseHandle(hPF);
	return size;
}

// gǂ݂
int fExist ( char* file)
{
//	int size=CPack::Exist(file);
//	if(size>=0)return size;
	HANDLE hPF= CreateFile(file, GENERIC_READ, 0, NULL, OPEN_EXISTING,
		FILE_ATTRIBUTE_NORMAL, NULL);
	if(hPF == INVALID_HANDLE_VALUE)return 0;
	int size=(int)GetFileSize(hPF, NULL);
	CloseHandle(hPF);
	return size;
}

bool CGrph::LoadPic(char *lpPath){

	int size=fExist(lpPath);
	if(size<=0)return false;
	HGLOBAL hGlobal = GlobalAlloc(GPTR, size);
	//	ǂݍ
	fLoad((char*)hGlobal,lpPath,size);
	int f=LoadKPC((LPBYTE)hGlobal);
	//if(!f)f=LoadBySPI((LPBYTE)hGlobal,size,lpPath);
	if(!f)f=LoadBMP((LPBYTE)hGlobal,size,lpPath);
	if(!f)f=LoadByOle(hGlobal,size);
	GlobalFree(hGlobal);
	return true;
}

void undif(UCHAR* buf,int size){
	int i;
	UCHAR cc=0;
	for(i=0;i<size;i++){
		cc+=buf[i];
		buf[i]=cc;
	}
}

void unrle(UCHAR* obuf,UCHAR* ibuf,int size){
	//MessageBox(NULL,"OK start","Debug",MB_OK);
	int i=0,o=0,l=0;
	while(o<size){
		l=*(unsigned short*)(ibuf+i);
		i+=2;
		if(l&32768){
			l-=32768;
			memset(obuf+o,*(ibuf+i),l);
			i++;
			o+=l;
		}else{
			if(l==0)break;
			memcpy(obuf+o,ibuf+i,l);
			i+=l;
			o+=l;
		}
	}
	//MessageBox(NULL,"OK","Debug",MB_OK);
}
//*
bool CGrph::LoadBMP(BYTE* buf,int size,char *szPath)
{
	if(memcmp(buf,"BM",2)) return false;

	// BITMAP쐬
	LPBITMAPFILEHEADER bh = (LPBITMAPFILEHEADER)buf;
	LPBITMAPINFOHEADER ih = (LPBITMAPINFOHEADER)(buf + sizeof(BITMAPFILEHEADER));
	LPBITMAPINFO bi = (LPBITMAPINFO)(buf + sizeof(BITMAPFILEHEADER));
	LPBYTE img = buf + bh->bfOffBits;
	bms->Create(ih->biWidth,ih->biHeight,0);
	HBITMAP hBmp = CreateDIBitmap(bms->hdc,ih,CBM_INIT,img,bi,DIB_RGB_COLORS);
	if(!hBmp)return false;
	HDC mDC= CreateCompatibleDC(bms->hdc);
	SelectObject(mDC,hBmp);
	BitBlt(bms->hdc,0,0,ih->biWidth,ih->biHeight,mDC,0,0,SRCCOPY);
	DeleteDC(mDC);
	DeleteObject(hBmp);
	return true;
}
	typedef struct KPCHEAD
	{
		char type[4];
		unsigned int file_size;
		short head_size;
		short flame;
		unsigned int sx;
		unsigned int sy;
		unsigned short mode;
		unsigned char planes;
		unsigned char flag; //?
	}KPCHEAD;
	typedef struct KPLIST
	{
		int size;
		//char dif;
		//char compf;
		unsigned dif:8;
		unsigned compf:1;
		unsigned rle:1;
		unsigned :0;
	}KPLIST;

bool CGrph::LoadKPC(BYTE* buf )
{
	return false;
}

bool CGrph::LoadByOle(HGLOBAL hGlobal, int size){
	IStream *iStream;
	IPicture *iPicture;
	long lWidth,lHeight;
	//GIF͓ǂ܂Ȃ
	if(!memcmp(hGlobal,"GIF",3)){
		MessageBox(NULL,"̂ߓǂݍ߂܂","G[",MB_OK);
		return false;
	}
	if(CreateStreamOnHGlobal(hGlobal, TRUE, &iStream)!=S_OK){
		return false;
	}
	if(OleLoadPicture(iStream, size, TRUE, IID_IPicture, (LPVOID*)&iPicture)!=S_OK){
		return false;
	}
	iPicture->get_Width(&lWidth); //lpVtbl-> iPicture,
	iPicture->get_Height(&lHeight);

	if(bms->flag==0){
		HDC hdc=CreateDC("DISPLAY",NULL,NULL,NULL);
		int cxpi = GetDeviceCaps(hdc,LOGPIXELSX);
		int cypi = GetDeviceCaps(hdc,LOGPIXELSY);
		bms->Create(MulDiv(lWidth,cxpi,2540),
			MulDiv(lHeight,cypi,2540),0);
		DeleteDC(hdc);
	}
	//bms->Create(640,480,0); //}WbNio[?
	int i=iPicture->Render(bms->hdc, 0, 0, bms->sx, bms->sy, 0, lHeight, lWidth, -lHeight, NULL);//` /lpVtbl->

	iPicture->Release();	//C[W
	return i==S_OK;
}


