/////////////////////////////////////////////////////////////////////////////
//		Remote Contorol client	Ver.0.2a
//
//				Copyright(c) 2003 K.Kawahira
/////////////////////////////////////////////////////////////////////////////
//#define WINVER 0x0500
#include	<windows.h>
#include	<string>
#include	<vector>
#include	"resource.h"
#include	"image.h"
#include	"remote.h"
#include	"client.h"
using namespace std;

#ifndef SPI_GETFOREGROUNDLOCKTIMEOUT
#define SPI_GETFOREGROUNDLOCKTIMEOUT 0x2000
#define SPI_SETFOREGROUNDLOCKTIMEOUT 0x2001
#endif

#ifndef WM_MOUSEWHEEL
#define WM_MOUSEWHEEL 0x020A
#endif

#define APP_NAME "Client"
#define APP_VER "RemoteControl client Ver.0.3"
#define INI_FILENAME "remote.ini"

struct Config{
	string s;
	int port;
	string host;
	string passwd;
};

vector<Config> conf;

Client client;

/////////////////////////////////////////////////////////////////////////////


LRESULT CALLBACK WindowProc(HWND,UINT,WPARAM,LPARAM);
POINT pos;
POINT wsize;
SCROLLINFO scx;
SCROLLINFO scy;
HINSTANCE hInst;
CGrph CG;

HCONV hConv;
DWORD ddeInst;
HSZ hszService;
HSZ hszTopic;

HWND hMWnd;
HACCEL hAccel;


void GetIniFile(char* file){
	unsigned char *ini = (unsigned char*)file;
	long i,p=0;
	long l=GetModuleFileName(NULL,(char*)ini,MAX_PATH);
	for(i=0;i<l;i++){
		//QoCgpc
		if ((0x81<=ini[i] && ini[i]<=0x9f)
			|| (0xe0<=ini[i] && ini[i]<=0xec))
		{
			i++;
			continue;
		}
		if (ini[i]=='\\') p=i;
	}
	if (p)ini[p+1]=0;
	strcat((char*)ini,INI_FILENAME);
}


bool WinResize(HWND hWnd){
	pos.x=0;
	pos.y=0;
	RECT rt;
	int x,y;
	x=CG.bms->sx+GetSystemMetrics(SM_CXSIZEFRAME)*2;
	wsize.x=x;
	x=min(800,x);
	y=CG.bms->sy+120;
	wsize.y=y;
	y=min(600,y);
	SetWindowPos(hWnd,NULL,0,0,x,y,SWP_NOZORDER|SWP_NOMOVE);
	RECT w;
	GetClientRect(hWnd,&rt);
	GetWindowRect(hWnd,&w);
	y= w.bottom-w.top - rt.bottom +CG.bms->sy;
	int ws=GetWindowLong(hWnd,GWL_STYLE);
	if(ws&WS_HSCROLL){
		y-=GetSystemMetrics(SM_CYHSCROLL);
	}
	wsize.y=y;
	y=min(600,y);
	SetWindowPos(hWnd,NULL,0,0,x,y,SWP_NOZORDER|SWP_NOMOVE);
	HDC hDC=GetDC(hWnd);
	GetClientRect( hWnd, &rt );
	BitBlt(hDC,0,0,rt.right,rt.bottom,CG.bms->hdc,0,0,SRCCOPY);
	ReleaseDC(hWnd,hDC);
	return true;
}

void Scroll(HWND hWnd,int x,int y){
	x=max(-scx.nPos,x);
	x=min(CG.bms->sx-(int)scx.nPage-pos.x,x);
	y=max(-scy.nPos,y);
	y=min(CG.bms->sy-(int)scy.nPage-pos.y,y);
	if (y!=0 || x!=0) {
		pos.x+=x;
		scx.nPos = pos.x;
		SetScrollInfo(hWnd, SB_HORZ, &scx, TRUE);
		pos.y+=y;
		scy.nPos = pos.y;
		SetScrollInfo(hWnd, SB_VERT, &scy, TRUE);
		ScrollWindow(hWnd, -x, -y , NULL, NULL);
		UpdateWindow(hWnd);
	}
}


// 
bool Print(HWND hWnd){
	DOCINFO di;
	PRINTDLG pd;
	ZeroMemory(&di,sizeof(DOCINFO));
	ZeroMemory(&pd,sizeof(PRINTDLG));
	di.cbSize=sizeof(DOCINFO);
	di.lpszDocName="K-Viewer";
	pd.lStructSize=sizeof(PRINTDLG);
	pd.hwndOwner=hWnd;
	pd.Flags=PD_COLLATE | PD_HIDEPRINTTOFILE | PD_RETURNDC;
	pd.nCopies=1;
	if (0)
		pd.Flags|=PD_SELECTION;
	else
		pd.Flags|=PD_NOSELECTION;
	if (!PrintDlg(&pd))
		return false;
	int psx,psy;
	psx=GetDeviceCaps(pd.hDC,HORZRES);
	psy=GetDeviceCaps(pd.hDC,VERTRES);
	//SetAbortProc(pd.hDC,DlgProc);
	StartDoc(pd.hDC,&di);
	StartPage(pd.hDC);

	//AXyNgێg/k
	int x,y;
	x=psx;
	y=CG.bms->sy*psx/CG.bms->sx;
	if(y+64>psy){
		y=psy;
		x=CG.bms->sx*psy/CG.bms->sy;
	}
	SetStretchBltMode(pd.hDC,HALFTONE);
	StretchBlt(pd.hDC,0,0,x,y,CG.bms->hdc,0,0,CG.bms->sx,CG.bms->sy,SRCCOPY);

	EndPage(pd.hDC);
	EndDoc(pd.hDC);
	DeleteDC(pd.hDC);
	return true;
}

bool Save(HWND hWnd){
	OPENFILENAME file;
	char szFileName[512];
	lstrcpy(szFileName,"");
	memset(&file,0,sizeof(OPENFILENAME));
	file.lStructSize = sizeof(OPENFILENAME);
	file.hwndOwner = hWnd;
	file.lpstrFilter = "rbg}bv\0*.bmp\0ׂ(*.*)\0*.*\0";
	file.nFilterIndex = 1;
	file.lpstrFile = szFileName;
	file.nMaxFile = 512;
	file.lpstrTitle = "ۑ";
	file.lpstrDefExt = "bmp";
	file.Flags = OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT;
	if (GetSaveFileName(&file)==0) return false;
	BITMAPFILEHEADER  bmFH;
    memset(&bmFH , 0 , sizeof(bmFH));
    bmFH.bfType = 0x4d42;
    bmFH.bfOffBits =sizeof(BITMAPINFOHEADER) + sizeof(BITMAPFILEHEADER);
    bmFH.bfSize = CG.bms->bmih.biSizeImage + bmFH.bfOffBits;

	HANDLE hPF= CreateFile(szFileName, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS,
		FILE_ATTRIBUTE_NORMAL, NULL);
	if(hPF == INVALID_HANDLE_VALUE)return false;
	ULONG size;

    WriteFile(hPF, &bmFH, sizeof(bmFH), &size, NULL);
    //BITMAPINFOHEADER\̈ȉ
    WriteFile(hPF, &CG.bms->bmih, (DWORD)(sizeof(BITMAPINFOHEADER)), &size, NULL);
    WriteFile(hPF, CG.bms->pBit, (DWORD)(CG.bms->bmih.biSizeImage), &size, NULL);

	CloseHandle(hPF);
	return true;
}


bool AWait(HWND hWnd){
	MSG msg;
	while(PeekMessage(&msg,NULL,0,0,PM_NOREMOVE)){
		if(msg.message!=WM_QUIT){
			GetMessage(&msg,NULL,0,0);
			if (!TranslateAccelerator(hWnd, hAccel, &msg)) {
				//TranslateMessage(&msg);
				DispatchMessage(&msg);
			}
		}else return false;
	}
	return true;
}

//  Gg[|Cg
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
	LPSTR lpCmdLine, int CmdShow)
{
	HWND hWnd;
	MSG msg;	 // bZ[W

	//  EChENXo^
	WNDCLASS wc;
	wc.style		= CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc	= WindowProc;
	wc.cbClsExtra	= 0;
	wc.cbWndExtra	= 0;
	wc.hInstance	= hInstance;
	wc.hIcon		= LoadIcon(hInstance,MAKEINTRESOURCE(IDI_ICON1));
	wc.hCursor		= LoadCursor(NULL,IDC_ARROW);
	wc.hbrBackground= (HBRUSH)(COLOR_WINDOW+1);
	wc.lpszMenuName	= MAKEINTRESOURCE(IDR_MENU1);
	wc.lpszClassName= "K-View";
	if(!RegisterClass(&wc)) return 0;
	hInst=hInstance;

	hWnd=CreateWindow("K-View",APP_NAME,
						WS_OVERLAPPEDWINDOW,
						CW_USEDEFAULT,
						CW_USEDEFAULT,
						GetSystemMetrics(SM_CXSCREEN)/2,
						GetSystemMetrics(SM_CYSCREEN)/2,
						NULL,
						(HMENU)NULL,
						hInstance, 0);
	if(!hWnd) return 0;
	wsize.x=GetSystemMetrics(SM_CXSCREEN)/2;
	wsize.y=GetSystemMetrics(SM_CYSCREEN)/2;

	hAccel = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDR_ACCELERATOR1));

	EnableMenuItem(GetMenu(hWnd),IDM_FILESAVE,MF_GRAYED);
	EnableMenuItem(GetMenu(hWnd),IDM_PRINT,MF_GRAYED);
//	EnableMenuItem(GetMenu(hWnd),IDM_EDITCOPY,MF_GRAYED);
	EnableMenuItem(GetMenu(hWnd),IDM_EDITPASTE2,MF_GRAYED);

	EnableMenuItem(GetMenu(hWnd),IDM_REMOTECLOSE,MF_GRAYED);
	EnableMenuItem(GetMenu(hWnd),IDM_REMOTEWAIT,MF_GRAYED);
	EnableMenuItem(GetMenu(hWnd),IDM_REMOTETRACE,MF_GRAYED);
	EnableMenuItem(GetMenu(hWnd),IDM_REMOTECONTROL,MF_GRAYED);

	CG.bms=new CBitmap;
	CG.bms->Create(320,240,0);
	memset(CG.bms->pBit,255,320*240*3);
	if(lpCmdLine[0]){
		//MessageBox(hWnd,lpCmdLine,"debug",MB_OK);
		char p[1024];
		int i=0;
		if(lpCmdLine[0]=='"'){
			i=1;
		}
		strcpy(p,lpCmdLine+i);
		if(i){
			i=strlen(p);
			p[i-1]=0;
		}
	}


	// ݒǂݍ
	char inifile[MAX_PATH];
	GetIniFile(inifile);
	Config c;
	int i;
	for(i=0;i<10;i++) {
		char s[256],s1[64];
		wsprintf(s1,"Host%02d",i);
		GetPrivateProfileString("Client",s1,"\a",s,sizeof(s),inifile);
		if (!s[0] || s[0]=='\a') break;
		c.host = s;
		wsprintf(s1,"Port%02d",i);
		c.port = GetPrivateProfileInt("Client",s1,9876,inifile);
		wsprintf(s1,"Passwd%02d",i);
		GetPrivateProfileString("Client",s1,"\a",s,sizeof(s),inifile);
		if (s[0]=='\a') s[0]='\0';
		c.passwd = s;
		wsprintf(s,"%s:%d",c.host.c_str(),c.port);
		c.s = s;
		conf.push_back(c);
	}


	ShowWindow(hWnd,CmdShow);
	UpdateWindow(hWnd);
	DragAcceptFiles(hWnd, TRUE);

	//  bZ[W[v
	int stat=0;
	while(AWait(hWnd)){
		if(client.isConnect()){
			while((stat=client.CmdRecv(hWnd,CG.bms))>0);
			if(stat<0){
				client.DisConnect(hWnd);
				MessageBox(hWnd,"ؒf܂","Error.",MB_OK);
			}
		}
		Sleep(10);
	}
	while(GetMessage(&msg,NULL,0,0))
	{
		if (!TranslateAccelerator(hWnd, hAccel, &msg)) {
			//TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}
	delete CG.bms;
	return  msg.wParam;
}

int keydat[256];
LRESULT CALLBACK InputHostDlgProc(HWND hWnd,UINT message,WPARAM wParam,LPARAM lParam);
LRESULT CALLBACK ShellExecDlgProc(HWND hWnd,UINT message,WPARAM wParam,LPARAM lParam);

//  CEChEvV[W
LRESULT CALLBACK WindowProc(HWND hWnd,UINT message,WPARAM wParam,LPARAM lParam)
{
	static PAINTSTRUCT ps;
	static HDC hDC;
	static int count;
	int f=0;
	switch(message)
	{
		case WM_CREATE:
			count=GetTickCount();
			break;
		case WM_COMMAND:
			switch(LOWORD(wParam))
			{
				case IDM_ABOUT:
					MessageBox(hWnd,APP_VER "\n"
						"\tCopyright 2003-2007 K-K","About RemoteControl client",MB_OK);
					break;
				case IDM_PRINT:
					Print(hWnd);
					break;
				case IDM_FILEOPEN:
					//Open(hWnd);
					break;
				case IDM_FILESAVE:
					Save(hWnd);
					break;
				case IDM_AUTOSCROLL:
					CheckMenuItem(GetMenu(hWnd),IDM_AUTOSCROLL,
						GetMenuState(GetMenu(hWnd),IDM_AUTOSCROLL,MF_BYCOMMAND)&MF_CHECKED?
						MF_UNCHECKED:MF_CHECKED);
					break;
				case IDM_CHKMOUSE:
					CheckMenuItem(GetMenu(hWnd),IDM_CHKMOUSE,
						GetMenuState(GetMenu(hWnd),IDM_CHKMOUSE,MF_BYCOMMAND)&MF_CHECKED?
						MF_UNCHECKED:MF_CHECKED);
					break;
				case IDM_EDITCOPY:
					{
					HDC hdc = GetDC(hWnd);
					HDC hdc_mem = CreateCompatibleDC(hdc);
					HBITMAP hBitmap=CreateCompatibleBitmap(hdc, CG.bms->sx, CG.bms->sy);
					SelectObject(hdc_mem, hBitmap);
					BitBlt(hdc_mem,0,0,CG.bms->sx, CG.bms->sy,CG.bms->hdc,0,0,SRCCOPY);
					OpenClipboard(hWnd);
					EmptyClipboard();
					SetClipboardData(CF_BITMAP, hBitmap);
					CloseClipboard();
					DeleteDC(hdc_mem);
					DeleteDC(hdc);
					break;
					}
				case IDM_REMOTECONNECT:
					if(DialogBox(hInst,(LPSTR)IDD_DIALOG1,hWnd,(DLGPROC)InputHostDlgProc)
						==IDOK)
					{
						if(client.Connect(hWnd)==false){
							MessageBox(hWnd,"Connection Error","Debug",MB_OK);
							break;
						}
						int i;
						for(i=0;i<256;i++)
							keydat[i]=0;
					}
					client.ChgMode(2);
					break;
				case IDM_REMOTECLOSE:
					client.DisConnect(hWnd);
					break;
				case IDM_REMOTEWAIT:
					f?0:client.ChgMode(1);
					f=1;
				case IDM_REMOTETRACE:
					f?0:client.ChgMode(2);
					f=1;
				case IDM_REMOTECONTROL:
					f?0:client.ChgMode(3);
					f=1;
					CheckMenuRadioItem(GetMenu(hWnd),
						IDM_REMOTEWAIT,IDM_REMOTECONTROL,LOWORD(wParam),MF_BYCOMMAND);
					break;
				case IDM_REMOTEEXEC:
					DialogBox(hInst,(LPSTR)IDD_SHELLEXEC,hWnd,(DLGPROC)ShellExecDlgProc);
					break;
				case IDM_EXIT:
				   DestroyWindow( hWnd );
				   break;
			}
			break;
		case WM_DROPFILES:
			{
				char lpPath[1024];
				DragQueryFile((HDROP)wParam, 0, lpPath, sizeof(lpPath));
				// Upload?
				break;
			}
		case WM_PAINT:
			{
				hDC = BeginPaint (hWnd, &ps);
				RECT rt;
				GetClientRect( hWnd, &rt );
				BitBlt(hDC,0,0,rt.right,rt.bottom,CG.bms->hdc,pos.x,pos.y,SRCCOPY);
				EndPaint( hWnd, &ps );
			}
			break;
		case WM_SIZE:
			RECT rt;
			GetClientRect(hWnd, &rt);
			if(rt.right>=CG.bms->sx-pos.x){pos.x=CG.bms->sx-rt.right;}
			pos.x=max(0,pos.x);
			if(rt.bottom>=CG.bms->sy-pos.y){pos.y=CG.bms->sy-rt.bottom;}
			pos.y=max(0,pos.y);
			scx.cbSize = sizeof(SCROLLINFO);
			scx.fMask = SIF_POS | SIF_RANGE | SIF_PAGE;
			scx.nMin = 0;
			scx.nMax = CG.bms->sx-1;
			scx.nPage =  rt.right;
			scx.nPos = pos.x;
			SetScrollInfo(hWnd, SB_HORZ, &scx, TRUE);
			GetClientRect(hWnd, &rt);
			scy.cbSize = sizeof(SCROLLINFO);
			scy.fMask = SIF_POS | SIF_RANGE | SIF_PAGE;
			scy.nMin = 0;
			scy.nMax = CG.bms->sy-1;
			scy.nPage =  rt.bottom;
			scy.nPos = pos.y;
			SetScrollInfo(hWnd, SB_VERT, &scy, TRUE);
			break;
		case WM_SIZING:
			{
			int x=wsize.x,y=wsize.y;
			int ws=GetWindowLong(hWnd,GWL_STYLE);
			if(ws & WS_HSCROLL)
				y+=GetSystemMetrics(SM_CYHSCROLL);
			if(ws & WS_VSCROLL)
				x+=GetSystemMetrics(SM_CXVSCROLL);

			((RECT*)lParam)->right=min(x+((RECT*)lParam)->left,((RECT*)lParam)->right);
			((RECT*)lParam)->bottom=min(y+((RECT*)lParam)->top,((RECT*)lParam)->bottom);
			}
			break;
		case WM_LBUTTONDOWN:
		case WM_LBUTTONUP:
		case WM_RBUTTONDOWN:
		case WM_RBUTTONUP:
		case WM_MBUTTONDOWN:
		case WM_MBUTTONUP:
			if(GetMenuState(GetMenu(hWnd),IDM_REMOTECONTROL,MF_BYCOMMAND)&MF_CHECKED){
				client.SendMouse(message,lParam+pos.x+(pos.y<<16));
			}
			break;
		case WM_SYSKEYDOWN:
		case WM_KEYDOWN:
		case WM_SYSKEYUP:
		case WM_KEYUP:
			if(GetMenuState(GetMenu(hWnd),IDM_REMOTECONTROL,MF_BYCOMMAND)&MF_CHECKED){
				int i,k;
				for(i=0;i<256;i++){
					k=(GetKeyState(i)>>15)&1;
					if(keydat[i]!=k){
						keydat[i]=k;
						client.SendKey(k^1,i);
					}
				}
			//	SendKey(0,wParam);
			}
			return  0;
		case WM_MOUSEMOVE:
			if(GetMenuState(GetMenu(hWnd),IDM_REMOTECONTROL,MF_BYCOMMAND)&MF_CHECKED
				&& GetMenuState(GetMenu(hWnd),IDM_CHKMOUSE,MF_BYCOMMAND)&MF_CHECKED)
			{
				int i=GetTickCount();
				if(count+500<i){
					count=i;
					client.SendMouse(0,lParam+pos.x+(pos.y<<16));
				}
			}
			if(GetMenuState(GetMenu(hWnd),IDM_AUTOSCROLL,MF_BYCOMMAND)&MF_CHECKED)
			{
				UINT x=LOWORD(lParam);
				UINT y=HIWORD(lParam);
				Scroll(hWnd, -16*(x<48) + 16*(x+48>scx.nPage),
					-16*(y<48) + 16*(y+48>scy.nPage));
			}
			break;
		case WM_MOUSEWHEEL:
			{
			int x=0,y=0;
			if(LOWORD(wParam)==MK_SHIFT){
				Scroll(hWnd,x,y);
				x=-(SHORT)HIWORD(wParam)*16/120;/* WHEEL_DELTA=120 */
			}else{
				y=-(SHORT)HIWORD(wParam)*16/120;
			}
			Scroll(hWnd,x,y);
			}
			break;
		case WM_HSCROLL:
			{
			int x;
			switch (LOWORD(wParam)) {
			case SB_LINEUP:
				x = -10;
				break;
			case SB_LINEDOWN:
				x = 10;
				break;
			case SB_PAGEUP:
				x = -80;
				break;
			case SB_PAGEDOWN:
				x = 80;
				break;
			case SB_THUMBTRACK:
				x = HIWORD(wParam) - pos.x;
				break;
			default:
				x = 0;
				break;
			}
			Scroll(hWnd,x,0);
            break;
			}
		case WM_VSCROLL:
			{
			int y;
			if(message==WM_MOUSEWHEEL)
				y=-(SHORT)HIWORD(wParam)*16/120;/* WHEEL_DELTA=120 */
			else
			switch (LOWORD(wParam)) {
			case SB_LINEUP:
				y = -10;
				break;
			case SB_LINEDOWN:
				y = 10;
				break;
			case SB_PAGEUP:
				y = -80;
				break;
			case SB_PAGEDOWN:
				y = 80;
				break;
			case SB_THUMBTRACK:
				y = HIWORD(wParam) - pos.y;
				break;
			default:
				y = 0;
				break;
			}
			Scroll(hWnd,0,y);
            break;
			}
		case WM_DESTROY:
			PostQuitMessage(0);
			return  0;
	}
	return  DefWindowProc(hWnd,message,wParam,lParam);
}

//  zXgݒ_CAO
LRESULT CALLBACK InputHostDlgProc(HWND hWnd,UINT message,WPARAM wParam,LPARAM lParam)
{
	switch(message)
	{
		case WM_INITDIALOG:
			{
				unsigned int i=0;
				for(i=0;i<conf.size();i++){
					SendMessage(GetDlgItem(hWnd, IDC_COMBO1), CB_INSERTSTRING,
						(WPARAM)i, (LPARAM)conf[i].s.c_str());
				}
				SendMessage(GetDlgItem(hWnd, IDC_COMBO1), CB_SETCURSEL, (WPARAM)0, 0L);
				if (conf.size()>0) {
					SetDlgItemInt(hWnd,IDC_PORT ,conf[0].port,FALSE);
					SetDlgItemText(hWnd,IDC_EDIT1 ,conf[0].host.c_str());
					SetDlgItemText(hWnd,IDC_EDIT2 ,conf[0].passwd.c_str());
				} else {
					SetDlgItemInt(hWnd,IDC_PORT ,9876,FALSE);
					SetDlgItemText(hWnd,IDC_EDIT1 ,"127.0.0.1");
					SetDlgItemText(hWnd,IDC_EDIT2 ,"");
				}
			}
			break;
		case WM_COMMAND:
			switch(LOWORD(wParam))
			{
				case IDC_COMBO1:
					switch (HIWORD(wParam)) {
						case CBN_SELCHANGE:
							int i=(int)SendMessage(GetDlgItem(hWnd, IDC_COMBO1), CB_GETCURSEL, 0L, 0L);
							SetDlgItemInt(hWnd,IDC_PORT ,conf[i].port,FALSE);
							SetDlgItemText(hWnd,IDC_EDIT1 ,conf[i].host.c_str());
							SetDlgItemText(hWnd,IDC_EDIT2 ,conf[i].passwd.c_str());
							break;
					}
					break;
				case IDOK:
				{
					char s[256],s1[64];
					client.port=GetDlgItemInt(hWnd,IDC_PORT,NULL,FALSE);
					GetDlgItemText(hWnd,IDC_EDIT1 ,client.host,256);
					GetDlgItemText(hWnd,IDC_EDIT2 ,client.passwd,128);
					char inifile[MAX_PATH];
					unsigned int i;
					wsprintf(s,"%d",client.port);
					GetIniFile(inifile);

					wsprintf(s,"%s:%d",client.host,client.port);
					for(i=0;i<conf.size();i++) {
						if (conf[i].s == s) {
							conf.erase(conf.begin()+i);
						}
					}
					Config c;
					c.host = client.host;
					c.port = client.port;
					c.passwd = client.passwd;
					c.s = s;
					conf.insert(conf.begin(),c);
					for(i=0;i<conf.size();i++) {
						wsprintf(s1,"Host%02d",i);
						WritePrivateProfileString("Client",s1,conf[i].host.c_str(),inifile);
						wsprintf(s,"%d",conf[i].port);
						wsprintf(s1,"Port%02d",i);
						WritePrivateProfileString("Client",s1,s,inifile);
						wsprintf(s1,"Passwd%02d",i);
						WritePrivateProfileString("Client",s1,conf[i].passwd.c_str(),inifile);
					}
					wsprintf(s1,"Host%02d",i);
					WritePrivateProfileString("Client",s1,"",inifile);


					EndDialog(hWnd, IDOK);
					break;
				}
				case IDCANCEL:
					EndDialog(hWnd, IDCANCEL);
					break;
			}
			break;
		case WM_DESTROY:
			return 0;
	}
	return FALSE;
}


//  R}hs_CAO
LRESULT CALLBACK ShellExecDlgProc(HWND hWnd,UINT message,WPARAM wParam,LPARAM lParam)
{
	switch(message)
	{
		case WM_INITDIALOG:
			{
				SetDlgItemText(hWnd,IDC_EDIT1 ,"");
			}
			break;
		case WM_COMMAND:
			switch(LOWORD(wParam))
			{
				case IDOK:
				{
					char sCmd[1024];
					GetDlgItemText(hWnd,IDC_EDIT1 ,sCmd,1024);
					client.SendCmd(sCmd);
					EndDialog(hWnd, IDOK);
					break;
				}
				case IDCANCEL:
					EndDialog(hWnd, IDCANCEL);
					break;
			}
			break;
		case WM_DESTROY:
			return 0;
	}
	return FALSE;
}

