#include	<winsock.h>
#pragma comment(lib, "wsock32.lib")

#include	"sock.h"

void RC4::init(void *k,  int len)
{
	char *key = (char*)k;
	if (!key) {
		mode = 0;
		return;
	}
	if(len==0) len=strlen(key);
	int i, a, b;
	mode = 1;

	x = y = 0;
	for(i=0; i < 256; i++ ) m[i] = i;
	for(i=0; i < 256; i++ ){
		a = m[i];
		b = ( b + a + (unsigned char)key[i%len] ) &0xff;
		m[i] = m[b];
		m[b] = a;
	}

	// dummy
	for(i=0; i < 256; i++ ){
		x = (x+1)&0xff;
		a = m[x];
		y = (y+a)&0xff;
		m[x] = b = m[y];
		m[y] = a;
	}
}

void RC4::crypt(void *dst, void *src, int len )
{
	unsigned char *data=(unsigned char*)src;
	unsigned char *t=(unsigned char*)dst;
	int i, a, b;
	if (!mode) {
		if (dst!=src) {
			for(i=0; i < len; i++ )
				t[i]=data[i];
		}
		return;
	}

	for(i=0; i < len; i++ ){
		x = (x+1)&0xff;
		a = m[x];
		y = (y+a)&0xff;
		m[x] = b = m[y];
		m[y] = a;
		t[i] = data[i]^m[(a+b)&0xff];
	}
}

Connection::Connection(){
	WSADATA WSAData;
	WSAStartup(0x0202,&WSAData);
	soc=INVALID_SOCKET;
}

Connection::~Connection(){
	close();
	WSACleanup();
}

int Connection::connect(char *host,int port) {
	sockaddr_in saddr;

	// \Pbg
	soc = socket(AF_INET, SOCK_STREAM, 0);
	if(soc == INVALID_SOCKET) return false;

	ULONG addr;		// T[oIP
	struct hostent *hostent;	// T[õzXg

	addr = inet_addr(host); // IP
	if(addr == -1) {
		hostent = gethostbyname(host);
		if (hostent == NULL) {
			return false;
		}else{
			// T[õzXg񂩂IPAhXaddrɃRs[
			addr = *((unsigned long *)((hostent->h_addr_list)[0]));
		}
	}

	// T[õAhX̍\̂ɃT[oIPAhXƃ|[gԍݒ肵܂ 
	saddr.sin_family	 = AF_INET;		// C^[lbg
	saddr.sin_addr.s_addr  = addr;		// IP
	saddr.sin_port	 = htons(port);		// |[g
	memset(saddr.sin_zero,(int)0,sizeof(saddr.sin_zero));

	// w̃\PbgŃT[oփRlNg
	if(::connect(soc,(struct sockaddr *)&saddr,sizeof(saddr)) == SOCKET_ERROR){
		return false;
	}
	return true;
}

int Connection::accept(int s,char *host,int *port) {
	sockaddr_in cAddr;
	int cAddrSize = sizeof(cAddr);
	soc = ::accept(s, (struct sockaddr *) &cAddr, &cAddrSize);
	*port = ntohs(cAddr.sin_port);
	strcpy(host,inet_ntoa(cAddr.sin_addr));

	return 0;
}

void Connection::close() {
	if (soc!=INVALID_SOCKET) {
		shutdown(soc, 2);
		closesocket(soc);
		soc=INVALID_SOCKET;
	}
}
int Connection::check() {
	int status;
	fd_set fdsetread;
	timeval t={0,1000};
	FD_ZERO(&fdsetread);
	FD_SET( soc,&fdsetread);
	status=select(1,&fdsetread,NULL,NULL,&t);
	return status;
}

int Connection::send(void *buf,int len) {
	int i=0,s,l;
	char tbuf[1024];
	while(i<len){
		l = (len-i>1024)?1024:len-i;
		rc4s.crypt(tbuf,(char*)buf+i,l);
		s = ::send(soc,tbuf,l,0);
//		s = ::send(soc,(char*)buf+i,len-i,0);
		if(s<1) return i;
		i+=s;
	}
	return len;
}

int Connection::recv(void *buf,int len) {
	int i=0,s;
	while(i<len){
		s=::recv(soc,(char*)buf+i,len-i,0);
		rc4r.crypt((char*)buf+i,(char*)buf+i,s);
		if(s<1) return i;
		i+=s;
	}
	return len;
}

