// RFC 1321

#ifndef _MD5_H
#define _MD5_H

#ifndef UINT32
typedef unsigned int UINT32;
#endif

#ifndef BYTE
typedef unsigned char BYTE;
#endif

class MD5 {
	UINT32 state[4];                                   /* state (ABCD) */
	UINT32 count[2];        /* number of bits, modulo 2^64 (lsb first) */
	BYTE buffer[64];                          /* input buffer */
	void Transform(UINT32 state[4], const unsigned char block[64]);
	void Encode( unsigned char *output, UINT32 *input, unsigned int len );
	void Decode( UINT32 *output, const unsigned char *input, unsigned int len );
public:
	void init();
	void update(BYTE* input,size_t inputLen);
	void final(BYTE digest[16]);
	static BYTE* hash(BYTE digest[16],BYTE *dat,size_t len);
	static char* str(char *s,BYTE digest[16]);
};

#endif

